Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/program_line.C
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/program_line.C	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/program_line.C	(revision 2696)
@@ -0,0 +1,136 @@
+
+// ############################################################################
+//
+//     create_mz_kpp_module                       
+//
+//     create vectorcode from .90 sources created by KPP to be used in MESSy
+//
+//     COPYRIGHT Klaus Ketelsen and MPI-CH   April 2007
+//
+// ############################################################################
+
+#include "program_line.h"
+
+void  program_line::set_line(string s) {
+
+   line = s;
+
+   tokens.fill_token(line);
+
+   return;
+}
+void  program_line::substitute(string old_s, string new_s) {
+
+   int pos = line.find (old_s, 0);       // look for string
+
+   if (pos != string::npos) {                // found
+     line.replace(pos,old_s.size(),new_s);
+   }   
+
+   return;
+}
+
+void  program_line::global_substitute(string old_s, string new_s) {
+   int         pos;
+
+   int start = line.size()-1;
+
+   while (1) {
+     pos = line.rfind (old_s, start);       // look for string
+
+     if (pos == string::npos) {
+       break;
+     }
+
+     line.replace(pos,old_s.size(),new_s);
+
+     start = pos-1;
+   }
+
+   return;
+}
+
+int  program_line::get_token_number_from_string (string s) {
+
+   for (int i=0; i<tokens.size(); i++) {
+     if(tokens.get_token_by_index(i) == s)  {
+       return i;
+     }
+   }
+
+   return -1;
+}
+
+int  program_line::get_token_number_from_string_upper (string s) {
+
+   string s1 = my_to_upper(s);
+   for (int i=0; i<tokens.size(); i++) {
+     if(my_to_upper(tokens.get_token_by_index(i)) == s1)  {
+       return i;
+     }
+   }
+
+   return -1;
+}
+
+void  program_line::update_token (int i, string s) {
+
+  string s_old=tokens.get_token_by_index(i);
+  tokens.update (i,s);
+  int pos=tokens.get_position(i);
+  line.replace(pos,s_old.size(),s);
+
+  return;
+}
+
+void  program_line::change_variable_to_vector (string var) {
+  string   U_token;
+
+  int     ind = tokens.size()-2;
+  for (int i=ind; i >= 0; i--) {
+    U_token.clear();
+    U_token = my_to_upper(tokens.get_token_by_index(i));
+    if(U_token == my_to_upper(var) && tokens.get_token_by_index(i+1) == "(" ) {
+      string new_s="(1:VL,";
+      tokens.update (i+1,new_s);
+      int pos=tokens.get_position(i+1);
+      line.replace(pos,1,new_s);
+      tokens.reset (line);
+    }
+  }
+
+  return;
+}
+
+void  program_line::change_variable_to_vector_g (Vvar &var) {
+  string   U_token;
+  string   new_s;
+
+  tokens.reset (line);
+
+  int     ind = tokens.size()-2;
+  for (int i=ind; i >= 0; i--) {
+    U_token.clear();
+    U_token = tokens.get_token_by_index(i);
+    if(var.nr_dim() == 0) {
+      if(my_to_upper(U_token) == my_to_upper(var.name) ) {
+        new_s=U_token + "(k)";
+        tokens.update (i,new_s);
+        int pos=tokens.get_position(i);
+        line.replace(pos,U_token.size(),new_s);
+        tokens.reset (line);
+      }
+    } else {
+      if(my_to_upper(U_token) == my_to_upper(var.name) && tokens.get_token_by_index(i+1) == "(" ) {
+        new_s="(k,";
+        tokens.update (i+1,new_s);
+        int pos=tokens.get_position(i+1);
+        line.replace(pos,1,new_s);
+        tokens.reset (line);
+      }
+    }
+  }
+
+  return;
+}
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/program_line.h
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/program_line.h	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/program_line.h	(revision 2696)
@@ -0,0 +1,46 @@
+#ifndef PLINE
+#define PLINE 1
+
+// ############################################################################
+//
+//     create_mz_kpp_module                       
+//
+//     create code from .90 sources created by KPP to be used in MESSy
+//
+//     COPYRIGHT Klaus Ketelsen and MPI-CH   April 2007
+//
+// ############################################################################
+
+#include <iostream>
+
+#include <string>
+#include <list>
+#include <vector>
+
+#include "utils.h"
+
+using namespace std;
+
+class program_line {
+
+   string            line;
+   string_token      tokens;
+
+  public:
+
+   string get_line()          {return line;};
+   string get_token(int i)    {return tokens.get_token_by_index(i);};
+   int    get_token_size()    {return tokens.size();};
+
+   void   set_line(string s);
+   void   substitute(string old_s, string new_s);
+   void   global_substitute(string old_s, string new_s);
+   int    get_token_number_from_string (string s);
+   int    get_token_number_from_string_upper (string s);
+
+   void   update_token                 (int i, string s);
+   void   change_variable_to_vector    (string var);
+   void   change_variable_to_vector_g  (Vvar  &var);
+};
+
+#endif
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/utils.C
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/utils.C	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/utils.C	(revision 2696)
@@ -0,0 +1,85 @@
+
+// ############################################################################
+//
+//     create_mz_kpp_module 
+//
+//     create scalar code from .f90 sources created by KPP to be used in MESSy
+//
+//     COPYRIGHT Klaus Ketelsen and MPI-CH   April 2007
+//
+// ############################################################################
+
+//  mz_rs_20090111+
+// stdlib is necessary to define abort():
+#include <stdlib.h>
+//  mz_rs_20090111-
+
+#include "utils.h"
+
+void string_token::fill_token (string s) {
+   int      ip,ib;
+
+   string buf=s+" ";
+   size_val  = 0;
+
+   tokens.clear();
+   position.clear();
+
+// extract fields from buffer
+
+   int i=0;
+   int pos=0;
+   while( 1 ) {
+     while (1) {
+        ib = buf.find(seperator,0);
+        if(ib == string::npos)   break;
+        if(ib != 0)   break;
+        buf.erase(0,1);
+        pos++;
+     }
+     ip = buf.find(seperator,0);
+     if(ip == string::npos)   break;
+     tokens.push_back(buf.substr(0,ip));
+     position.push_back(pos);
+     size_val++;
+     buf.erase(0,ip);
+     pos += ib;
+
+     i++;
+   }
+
+   is = tokens.begin();
+
+   return;
+};
+
+
+void my_abort (string s) {
+   cout << "*** ERROR: " << s  <<endl;
+   abort();
+
+   return;
+}
+
+string my_to_upper(string sinp) {
+  string       s1,s2;
+
+  const char   *c1;
+  char         c2[2];
+  int          i1,i2;
+
+  for(int i=0; i<sinp.size(); i++) {
+    s1.clear();
+    s1 = sinp.substr(i,1);
+    c1 = s1.c_str();
+
+    i1 = *c1;
+    i2 = toupper(i1);
+    *c2 = i2;
+    c2[1] = 0;
+
+    s2 += c2;
+  }
+
+  return s2;
+}
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/utils.h
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/utils.h	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/utils.h	(revision 2696)
@@ -0,0 +1,91 @@
+#ifndef UTIL
+#define UTIL 1
+
+// ############################################################################
+//
+//     create_mz_kpp_module 
+//
+//     create scalar code from .f90 sources created by KPP to be used in MESSy
+//
+//     COPYRIGHT Klaus Ketelsen and MPI-CH   April 2007
+//
+// ############################################################################
+
+#include <string>
+#include <list>
+#include <vector>
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+extern void my_abort(string s);
+extern string my_to_upper(string sinp);
+
+class Vvar {
+ public:
+  string                name;
+  vector<string>        dim_var;
+
+  int nr_dim() {return dim_var.size(); };
+  void clear() {name.clear(); dim_var.clear(); return; };
+};
+
+class control_switches {
+ private:
+  bool   vector_mode;            // false     Generate scalar code
+                                 // true      Generate vector code
+
+  string vector_length;
+
+  int de_index_mode;              // 0: no de-indexing
+                                  // 1: normal de-indexing
+                                  // 2: 'fast' de-indexing  (LU)
+                                  // 3: 'old' de-indexing
+
+ public:
+
+  void   set_vector_mode()              {vector_mode = true; return;};
+  void   set_vector_length (string s)   {vector_length=s; return;};
+  void   set_de_index_mode(int i)       {de_index_mode = i; return;};
+
+
+  bool   is_vector()           {return vector_mode;};
+  string get_vector_length ()  {return vector_length;};
+  int de_indexing ()           {return de_index_mode;};
+
+  control_switches () {vector_mode = false; vector_length="1"; de_index_mode=0;} 
+};
+
+extern control_switches kpp_switches;
+
+class string_token {
+ private:
+  int                         size_val;
+  string                      seperator;
+  vector <string>             tokens;
+  vector <string>::iterator   is;
+  vector <int>                position;
+
+ public:
+    void set_separator (string s) {seperator.clear();seperator=s; return; };
+
+    void    fill_token (string s);
+    bool    get_next_token(string &s) { s=*is++; return (is == tokens.end()); };
+    string  get_token_by_index (int index) { if(index <= size_val-1) {
+                                               return tokens[index]; 
+                                             } else {
+                                               return " "; }; };
+    int     size()                         { return size_val; };
+    void    update (int i, string s)       { tokens[i].clear(); tokens[i] = s;return;};
+    int     get_position(int i)            { return position[i]; };
+    void    reset (string s)               { tokens.clear(); fill_token (s); return; };
+
+
+    string_token ()         {size_val=0;seperator=" ";};
+    string_token (string s) {size_val=0;seperator=s;};
+
+};
+
+#endif
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/UserRateLaws.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/UserRateLaws.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/UserRateLaws.f90	(revision 2696)
@@ -0,0 +1,106 @@
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!  User-defined Rate Law functions
+!  Note: the default argument type for rate laws, as read from the equations file, is single precision
+!        but all the internal calculations are performed in double precision
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!
+! RFo: IMPORTANT: Comments must ALWAYS stand BEFORE the code to be processed
+!
+!      This is just the working copy of UserRateLaws.f90 which is actually used. 
+!      It is copied from GASPASE_PREPROC/mechanisms/UserRateLaws.f90 to kpp/util/UserRateLaws.f90
+!      each time when run_kpp4palm.ksh is run. 
+
+
+!~~~>  Arrhenius
+   KPP_REAL FUNCTION ARR( A0,B0,C0 )
+      REAL A0,B0,C0      
+      ARR =  DBLE(A0) * EXP(-DBLE(B0)/TEMP) * (TEMP/300.0_dp)**DBLE(C0)
+   END FUNCTION ARR        
+
+
+!~~~> Simplified Arrhenius, with two arguments, fixed TEMP=20 deg C
+!~~~> Note: The argument B0 has a changed sign when compared to ARR
+!
+!~~~> Simplified Arrhenius, with two arguments
+! RFo: same as above, but with TEMP in parameter list and _dp
+!  KPP_REAL (kind=dp) FUNCTION ARR2( A0, B0 )
+!     REAL (kind=dp) A0,B0
+!     ARR2 =  A0 * EXP( B0 / 20.0_dp )
+!  END FUNCTION ARR2
+REAL(kind=dp) FUNCTION ARR2( a0, b0, temp )
+    REAL(kind=dp) :: temp
+    REAL(kind=dp) :: a0,b0
+    ARR2 = a0 * EXP( -b0 / temp )
+END FUNCTION ARR2
+
+
+   KPP_REAL FUNCTION EP2(A0,C0,A2,C2,A3,C3)
+      REAL A0,C0,A2,C2,A3,C3
+      REAL(kind=dp) K0,K2,K3            
+      K0 = DBLE(A0) * EXP(-DBLE(C0)/TEMP)
+      K2 = DBLE(A2) * EXP(-DBLE(C2)/TEMP)
+      K3 = DBLE(A3) * EXP(-DBLE(C3)/TEMP)
+      K3 = K3*CFACTOR*1.0E6_dp
+      EP2 = K0 + K3/(1.0_dp+K3/K2 )
+   END FUNCTION EP2
+
+   KPP_REAL FUNCTION EP3(A1,C1,A2,C2) 
+      REAL A1, C1, A2, C2
+      REAL(kind=dp) K1, K2      
+      K1 = DBLE(A1) * EXP(-DBLE(C1)/TEMP)
+      K2 = DBLE(A2) * EXP(-DBLE(C2)/TEMP)
+      EP3 = K1 + K2*(1.0E6_dp*CFACTOR)
+   END FUNCTION EP3 
+
+   KPP_REAL FUNCTION FALL ( A0,B0,C0,A1,B1,C1,CF)
+      REAL A0,B0,C0,A1,B1,C1,CF
+      REAL(kind=dp) K0, K1     
+      K0 = DBLE(A0) * EXP(-DBLE(B0)/TEMP)* (TEMP/300.0_dp)**DBLE(C0)
+      K1 = DBLE(A1) * EXP(-DBLE(B1)/TEMP)* (TEMP/300.0_dp)**DBLE(C1)
+      K0 = K0*CFACTOR*1.0E6_dp
+      K1 = K0/K1
+      FALL = (K0/(1.0_dp+K1))*   &
+           DBLE(CF)**(1.0_dp/(1.0_dp+(LOG10(K1))**2))
+   END FUNCTION FALL
+
+  !---------------------------------------------------------------------------
+
+  ELEMENTAL REAL(kind=dp) FUNCTION k_3rd(temp,cair,k0_300K,n,kinf_300K,m,fc)
+
+    INTRINSIC LOG10
+
+    REAL(kind=dp), INTENT(IN) :: temp      ! temperature [K]
+    REAL(kind=dp), INTENT(IN) :: cair      ! air concentration [molecules/cm3]
+    REAL, INTENT(IN) :: k0_300K   ! low pressure limit at 300 K
+    REAL, INTENT(IN) :: n         ! exponent for low pressure limit
+    REAL, INTENT(IN) :: kinf_300K ! high pressure limit at 300 K
+    REAL, INTENT(IN) :: m         ! exponent for high pressure limit
+    REAL, INTENT(IN) :: fc        ! broadening factor (usually fc=0.6)
+    REAL(kind=dp) :: zt_help, k0_T, kinf_T, k_ratio
+
+    zt_help = 300._dp/temp
+    k0_T    = k0_300K   * zt_help**(n) * cair ! k_0   at current T
+    kinf_T  = kinf_300K * zt_help**(m)        ! k_inf at current T
+    k_ratio = k0_T/kinf_T
+    k_3rd   = k0_T/(1._dp+k_ratio)*fc**(1._dp/(1._dp+LOG10(k_ratio)**2))
+
+  END FUNCTION k_3rd
+
+  !---------------------------------------------------------------------------
+
+  ELEMENTAL REAL(kind=dp) FUNCTION k_arr (k_298,tdep,temp)
+    ! Arrhenius function
+
+    REAL,     INTENT(IN) :: k_298 ! k at T = 298.15K
+    REAL,     INTENT(IN) :: tdep  ! temperature dependence
+    REAL(kind=dp), INTENT(IN) :: temp  ! temperature
+
+    INTRINSIC EXP
+
+    k_arr = k_298 * EXP(tdep*(1._dp/temp-3.3540E-3_dp)) ! 1/298.15=3.3540e-3
+
+  END FUNCTION k_arr
+
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!  End of User-defined Rate Law functions
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_passive/chem_gasphase_mod.kpp
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_passive/chem_gasphase_mod.kpp	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_passive/chem_gasphase_mod.kpp	(revision 2696)
@@ -0,0 +1,36 @@
+//chem_gasphase_mod.kpp
+//
+//Former revisions
+//----------------
+// $Id: chem_gasphase_mod.kpp 2459 2017-09-13 14:10:33Z forkel $
+//
+#include      passive.spc
+#include      passive.eqn
+#INTEGRATOR rosenbrock
+#LANGUAGE   Fortran90
+#HESSIAN    on
+#STOICMAT   on
+#INLINE F90_GLOBAL
+  !   Declaration of global variable declarations for photolysis will come from INLINE F90_DATA
+#ENDINLINE
+//
+// *******************************************************************************************
+// *** adapt the lines below occurding to the photolysis reactions of your mechanism         *
+// *** adapt the number of photolysis frequencies NPHO                                       *
+// *** adapt/extend the indices in the INTEGER, PARAMETER,PUBLIC statement below             *
+// *** adapt/extend PHOT_NAMES: Note that the order of PHOT_NAMES and the indices must match *
+// *******************************************************************************************
+//
+#INLINE F90_DATA
+  !   INLINE F90_DATA: Declaration of global variables for photolysis
+  !   REAL(kind=dp) :: phot(nphot) must eventually be moved to GLOBAL later for vector version
+  INTEGER, PARAMETER :: nphot = 1
+  !   phot Photolysis frequencies
+  REAL(kind=dp) :: phot(nphot)
+
+  INTEGER, PARAMETER,PUBLIC :: j_no2 = 1
+
+  CHARACTER(LEN=15), PARAMETER, DIMENSION(NPHOT) :: phot_names =  (/ &
+     'J_NO2          '/)
+#ENDINLINE
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_passive/passive.eqn
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_passive/passive.eqn	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_passive/passive.eqn	(revision 2696)
@@ -0,0 +1,10 @@
+{passive.eqn
+Former revisions
+----------------
+ $Id$
+}
+#EQUATIONS
+
+{ passive: does nothing }
+  { 1.}  PM10 = PM10 :                   1.0_dp  ;
+  { 2.}  PM25 = PM25 :                   1.0_dp  ;
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_passive/passive.spc
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_passive/passive.spc	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_passive/passive.spc	(revision 2696)
@@ -0,0 +1,19 @@
+{passive.spc
+Former revisions
+----------------
+ $Id$
+}
+#include atoms
+
+ #DEFVAR
+    PM10    = ignore ;
+    PM25    = ignore ;
+
+#DEFFIX
+    H2O         = H + 2O ;      {water}
+    H2          = 2H ;          {molecular hydrogen}
+    O2      = 2O ;          {molecular oxygen}
+    N2      = 2N ;          {molecular nitrogen}
+    CH4         = C + 4H ;      {methane}
+    CO2     = C + 2O ;      {carbon dioxide}
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_simple/chem_gasphase_mod.kpp
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_simple/chem_gasphase_mod.kpp	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_simple/chem_gasphase_mod.kpp	(revision 2696)
@@ -0,0 +1,37 @@
+//chem_gasphase_mod.kpp
+//
+//Former revisions
+//----------------
+// $Id: chem_gasphase_mod.kpp 2459 2017-09-13 14:10:33Z forkel $
+//
+#include      simple.spc
+#include      simple.eqn
+#INTEGRATOR rosenbrock
+#LANGUAGE   Fortran90
+#HESSIAN    on
+#STOICMAT   on
+#INLINE F90_GLOBAL
+  !   Declaration of global variable declarations for photolysis will come from INLINE F90_DATA
+#ENDINLINE
+//
+// *******************************************************************************************
+// *** adapt the lines below occurding to the photolysis reactions of your mechanism         *
+// *** adapt the number of photolysis frequencies NPHO                                       *
+// *** adapt/extend the indices in the INTEGER, PARAMETER,PUBLIC statement below             *
+// *** adapt/extend PHOT_NAMES: Note that the order of PHOT_NAMES and the indices must match *
+// *******************************************************************************************
+//
+#INLINE F90_DATA
+  !   INLINE F90_DATA: Declaration of global variables for photolysis
+  !   REAL(kind=dp) :: phot(nphot) must eventually be moved to GLOBAL later for vector version
+  INTEGER, PARAMETER :: nphot = 2
+  !   phot Photolysis frequencies 
+  REAL(kind=dp) :: phot(nphot)
+
+  INTEGER, PARAMETER,PUBLIC :: j_no2 = 1
+  INTEGER, PARAMETER,PUBLIC :: j_o31d = 2
+
+  CHARACTER(LEN=15), PARAMETER, DIMENSION(NPHOT) :: phot_names =  (/ &
+     'J_NO2          ','J_O31D         '/)
+#ENDINLINE
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_simple/simple.eqn
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_simple/simple.eqn	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_simple/simple.eqn	(revision 2696)
@@ -0,0 +1,15 @@
+{simple.eqn
+Former revisions
+----------------
+ $Id: smog.eqn 2459 2017-09-13 14:10:33Z forkel $
+}
+#EQUATIONS
+
+{ very simple mechanism - do NOT show to a chemist! }
+
+  { 1.}  NO2 + hv = NO + O3 :                   phot(j_no2)  ;
+  { 2.}  O3 + hv = 2OH + O2 :                   phot(j_o31d)  ;
+  { 3.}  NO + O3 = NO2 :                     arr2(1.8E-12_dp, 1370.0_dp, temp) ;
+  { 4.}  RH + OH = RO2 + H2O :               arr2(2.E-11_dp, 500.0_dp, temp) ;
+  { 5.}  RO2 + NO = NO2 + RCHO + HO2 :       arr2(4.2E-12_dp, -180.0_dp, temp);
+  { 6.}  HO2 + NO = NO2 + OH :               arr2(3.7E-12_dp, -240.0_dp, temp) ;
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_simple/simple.spc
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_simple/simple.spc	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_simple/simple.spc	(revision 2696)
@@ -0,0 +1,42 @@
+{simple.spc
+Former revisions
+----------------
+ $Id: smog.spc 2459 2017-09-13 14:10:33Z forkel $
+}
+#include atoms
+
+ #DEFVAR  
+    O       = O ;      		{oxygen atomic ground state (3P)}
+    O3		= 3O ;          {ozone}  
+    NO		= N + O ;       {nitric oxide}  
+    NO2		= N + 2O ;      {nitrogen dioxide} 
+    NO3		= N + 3O ;      {nitrogen trioxide} 
+    N2O5	= 2N + 5O ;     {dinitrogen pentoxide}           
+    HNO3	= H + N + 3O ;  { nitric acid }
+    HNO4	= H + N + 4O ;  {HO2NO2 pernitric acid}
+    H           = H ;           {hydrogen atomic ground state (2S)}
+    OH		= O + H ;       {hydroxyl radical}  
+    HO2		= H + 2O ;      {perhydroxyl radical}                     
+    H2O2	= 2H + 2O ;     {hydrogen peroxide} 
+    CH3     = C + 3H ;      {methyl radical}
+    CH3O    = C + 3H + O ;  {methoxy radical}
+    CH3O2   = C + 3H + 2O ; {methylperoxy radical}
+    CH3OOH  = C + 4H + 2O ; {CH4O2      methylperoxy alcohol}
+    HCO     = H + C + O ;   {CHO  formyl radical}
+    CH2O    = C + 2H + O ;  {formalydehyde}
+    CO      = C + O ;       {carbon monoxide}   
+    
+    RH      = ignore ;
+    RO2     = ignore ;
+    RCHO    = ignore ;
+    RCOO2   = ignore ;
+    RCOO2NO2= ignore ;
+
+#DEFFIX
+    H2O		= H + 2O ;      {water}
+    H2		= 2H ;          {molecular hydrogen}
+    O2      = 2O ;          {molecular oxygen}              
+    N2      = 2N ;          {molecular nitrogen}              
+    CH4		= C + 4H ;      {methane} 
+    CO2     = C + 2O ;      {carbon dioxide}
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_smog/chem_gasphase_mod.kpp
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_smog/chem_gasphase_mod.kpp	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_smog/chem_gasphase_mod.kpp	(revision 2696)
@@ -0,0 +1,37 @@
+//chem_gasphase_mod.kpp
+//
+//Former revisions
+//----------------
+// $Id: chem_gasphase_mod.kpp 2459 2017-09-13 14:10:33Z forkel $
+//
+#include      smog.spc
+#include      smog.eqn
+#INTEGRATOR rosenbrock
+#LANGUAGE   Fortran90
+#HESSIAN    on
+#STOICMAT   on
+#INLINE F90_GLOBAL
+  !   Declaration of global variable declarations for photolysis will come from INLINE F90_DATA
+#ENDINLINE
+//
+// *******************************************************************************************
+// *** adapt the lines below occurding to the photolysis reactions of your mechanism         *
+// *** adapt the number of photolysis frequencies NPHO                                       *
+// *** adapt/extend the indices in the INTEGER, PARAMETER,PUBLIC statement below             *
+// *** adapt/extend PHOT_NAMES: Note that the order of PHOT_NAMES and the indices must match *
+// *******************************************************************************************
+//
+#INLINE F90_DATA
+  !   INLINE F90_DATA: Declaration of global variables for photolysis
+  !   REAL(kind=dp) :: phot(nphot) must eventually be moved to GLOBAL later for vector version
+  INTEGER, PARAMETER :: nphot = 2
+  !   phot Photolysis frequencies 
+  REAL(kind=dp) :: phot(nphot)
+
+  INTEGER, PARAMETER,PUBLIC :: j_no2 = 1
+  INTEGER, PARAMETER,PUBLIC :: j_rcho = 2
+
+  CHARACTER(LEN=15), PARAMETER, DIMENSION(NPHOT) :: phot_names =  (/ &
+     'J_NO2          ','J_RCHO         '/)
+#ENDINLINE
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_smog/smog.eqn
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_smog/smog.eqn	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_smog/smog.eqn	(revision 2696)
@@ -0,0 +1,22 @@
+{smog.eqn
+Former revisions
+----------------
+ $Id: smog.eqn 2612 2017-11-15 16:50:16Z forkel $
+}
+#EQUATIONS
+
+{ Photochemical Smog with photolysis}
+
+  { 1.}  NO2 + hv = NO + O :                   phot(j_no2)  ;
+  { 2.}  O + O2 = O3       :                 arr2(3.2e-11_dp,  -70.0_dp, temp) ;
+  { 3.}  NO + O3 = NO2 + O2 :                arr2(1.8E-12_dp, 1370.0_dp, temp) ;
+  { 4.}  RH + OH = RO2 + H2O :               arr2(2.E-11_dp, 500.0_dp, temp) ;
+  { 5.}  RCHO + OH = RCOO2 + H2O :           arr2(7.0E-12_dp, -250.0_dp, temp) ;
+  { 6.}  RCHO + hv = RO2 + HO2 + CO :        phot(j_rcho)    ;
+  { 7.}  HO2 + NO = NO2 + OH :               arr2(3.7E-12_dp, -240.0_dp, temp) ;
+  { 8.}  RO2 + NO = NO2 + RCHO + HO2 :       arr2(4.2E-12_dp, -180.0_dp, temp);
+  { 9.}  RCOO2 + NO = NO2 + RO2 + CO2 :      arr2(5.4E-12_dp, -250.0_dp, temp) ;
+  {10.}  OH + NO2 = HNO3 :                   arr2(1.0E-12_dp, -713.0_dp, temp) ;
+  {11.}  RCOO2 + NO2 = RCOO2NO2 :            arr2(1.2e-11_dp, 0.0_dp, temp) ;
+  {12.}  RCOO2NO2 = RCOO2 + NO2 :            arr2(9.4E+16_dp, 14000.0_dp, temp) ;
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_smog/smog.spc
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_smog/smog.spc	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_smog/smog.spc	(revision 2696)
@@ -0,0 +1,42 @@
+{smog.spc
+Former revisions
+----------------
+ $Id: smog.spc 2459 2017-09-13 14:10:33Z forkel $
+}
+#include atoms
+
+ #DEFVAR  
+    O       = O ;      		{oxygen atomic ground state (3P)}
+    O3		= 3O ;          {ozone}  
+    NO		= N + O ;       {nitric oxide}  
+    NO2		= N + 2O ;      {nitrogen dioxide} 
+    NO3		= N + 3O ;      {nitrogen trioxide} 
+    N2O5	= 2N + 5O ;     {dinitrogen pentoxide}           
+    HNO3	= H + N + 3O ;  { nitric acid }
+    HNO4	= H + N + 4O ;  {HO2NO2 pernitric acid}
+    H           = H ;           {hydrogen atomic ground state (2S)}
+    OH		= O + H ;       {hydroxyl radical}  
+    HO2		= H + 2O ;      {perhydroxyl radical}                     
+    H2O2	= 2H + 2O ;     {hydrogen peroxide} 
+    CH3     = C + 3H ;      {methyl radical}
+    CH3O    = C + 3H + O ;  {methoxy radical}
+    CH3O2   = C + 3H + 2O ; {methylperoxy radical}
+    CH3OOH  = C + 4H + 2O ; {CH4O2      methylperoxy alcohol}
+    HCO     = H + C + O ;   {CHO  formyl radical}
+    CH2O    = C + 2H + O ;  {formalydehyde}
+    CO      = C + O ;       {carbon monoxide}   
+    
+    RH      = ignore ;
+    RO2     = ignore ;
+    RCHO    = ignore ;
+    RCOO2   = ignore ;
+    RCOO2NO2= ignore ;
+
+#DEFFIX
+    H2O		= H + 2O ;      {water}
+    H2		= 2H ;          {molecular hydrogen}
+    O2      = 2O ;          {molecular oxygen}              
+    N2      = 2N ;          {molecular nitrogen}              
+    CH4		= C + 4H ;      {methane} 
+    CO2     = C + 2O ;      {carbon dioxide}
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/run_kpp4palm.ksh
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/run_kpp4palm.ksh	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/run_kpp4palm.ksh	(revision 2696)
@@ -0,0 +1,78 @@
+#!/bin/ksh
+#
+#--------------------------------------------------------------------------------#
+#
+# Current revisions:
+# ------------------
+# 
+# 
+# Former revisions:
+# -----------------
+# $Id: run_kpp4palm.ksh 2603 2017-11-03 17:44:45Z forkel $ 
+#
+# 
+# Small adaptations (added MECH as argument, re-introduced relative path,
+#                    adaption to changing kp4 to kpp4palm)
+# filename changed from run_kp4.ksh to run_kpp4palm.ksh
+# 
+# 
+# 
+#
+# Nov. 2016: Initial Version of KPP chemistry by Klaus Ketelsen
+#
+
+echo "\$1 = " $1 
+
+if [[ $1 == "clean" ]]
+then
+  cd kpp
+  make distclean
+  cd ..
+
+  cd kpp4palm
+  make distclean                 
+  cd ..
+  exit
+fi
+
+export PATH=$PATH:`pwd`/kpp4palm/bin
+
+# build kpp
+
+cp mechanisms/UserRateLaws.f90 kpp/util
+cd kpp
+make
+cd ..
+
+# build kpp4palm.exe
+
+cd kpp4palm
+make install                    
+cd ..
+
+# run kpp4palm with default Setup
+#    -d   DEFDIR=$OPTARG;;          # directory of definition files
+#    -i   DE_INDEX="YES";;          # if set, deindexing
+#    -f   DE_INDEX_FAST="YES";;     # if set, fast deindexing
+#    -k   KEEP="YES";;              # keep Working directory
+#    -o   OUTDIR=$OPTARG;;          # Output directory of Geneated Code
+#    -p   PREFIX=$OPTARG;;          # Name Prefix
+#    -s   KPP_SOLVER=$OPTARG;;      # Name Prefix
+
+ 
+echo $PATH
+# use smog mechnism as default
+MECH=smog
+
+while  getopts m:  opt   # get options
+do case $opt in
+      m)   MECH=$OPTARG;;          # mechanism name as part of mechanisms/def_[mechanism_name]
+
+      \?)  print ${0##*/} "unknown option:" $OPTARG
+           print "USAGE: ${0##*/} [ -m mechanism_name ] "
+           exit 1;;
+   esac
+done
+echo $MECH
+
+kpp4palm.ksh -d `pwd`/mechanisms/def_$MECH -k
